' Note that this file will make assumptions about the hardware -- specifically that it's a thalamoid board and that it can switch stuff on and off.



CON
  _clkmode = xtal1 + pll16x
'  _xinfreq = 6_000_000
  _clkfreq = 96_000_000


OBJ
  term : "FullDuplexSerial"
  adb:"adb-shell-module"
  outbuf:"stringoutput_external_buffer"
  inbuf:"stringoutput_external_buffer"
  adc:"AD7706-2wire.spin"
  p: "pinout"
  
PUB demo

  p.off(p#PWR_PHONE)
  p.on(p#PWR_ADC)
  adc.InitADC(p#ADC_CLOCK,p#ADC_DATA,p#ADC_DATA,-1)
  p.off(p#PWR_DEVICE1)
  p.off(p#PWR_DEVICE2)


  term.start(31,30,0,115200)
  outbuf.init(@outbufmem,256)
  inbuf.init(@inbufmem,128)
  errtimes~
  repeat
    term.str(string(" Sync",13,10))
    p.on(p#PWR_PHONE)
    result := \adb.PrimaryHandshake
    
    if result>-1
       result := \CommandLoop
    else
       lasterror:=result   

    if (result<>-999)
      term.dec(result)
      term.str(string(" Aborted",13,10))
      if (lasterror==result)
         if(lasterror <> -3) ' -3 is usb enumeration and is fixed by going back and changing IFD's, so it's a special case
            errtimes++
      else
         errtimes~
         lasterror:=result
      
      if errtimes>10'result == -135 or result == -4)
        term.str(string("Errors>tre, rebooting",13,10))
        p.off(p#PWR_PHONE)
        waitcnt(cnt+ constant(_clkfreq*2))      
        reboot
      p.on(p#PWR_PHONE)


con
CONNECTION_SHELL = 0
CONNECTION_LCAT = 1
CONNECTION_ADC = 2
CONNECTION_L = 3

var
long logcycle
var
byte lastcommand[129]
byte nextcommand[129]
var
long lasterror
byte errtimes
pri CommandLoop 

derpdebug
' connections:
' 3 is output to file
' 2 is ADC output to file
' 1 is input from logcat
' 0 is shell
CommandsExpected:=-10
logcycle:=log_period
logcycles~
globalecho~
'cmd (string("logcat -c",13,10),CONNECTION_LCAT)
cmd (string("logcat -c;logcat -v raw PB_IN:* *:S",13,10),CONNECTION_LCAT)
derpdebug
cmd (string("cd /data/local;chmod 666 ./PB_O_C",13,10),CONNECTION_L)
'derpdebug
'cmd (string("chmod 666 ./PB_O_C*",13,10),CONNECTION_L)
derpdebug
cmd (string("cd /data/local;chmod 666 ./PB_ADC_C",13,10),CONNECTION_ADC)
derpdebug
'cmd (string("chmod 666 ./PB_ADC_C",13,10),CONNECTION_ADC)
'derpdebug
cmd (string("cd /data/local",13,10),CONNECTION_SHELL)
derpdebug
globalecho~~

repeat

  derpdebug
  ExecuteCommandIfThere
  listen
  adc.GetChannel(0)        
  adc.GetChannel(1)        
  adc.GetChannel(2)        

  --logcycle
 if (logcycle==1)

      if (CommandQueued)
        cmd(@lastcommand,CONNECTION_SHELL)
        CommandQueued~

 'elseif (logcycle==2)

'      cmd(string("cat ./PB_ADC_C >> /sdcard/PB_ADC_L",13),CONNECTION_ADC)

 'elseif (logcycle==1)

    '  cmd(string("DATE=$(toolbox date ",quote,"+%Y %m %d %H %M %S",quote,");cat ./PB_ADC_C >> /sdcard/PB_ADC_L",13),CONNECTION_ADC)

 elseif (logcycle==0) ' asynchronous stuff here (in this case, dump to ADC)

      outbuf.zap(0)
      outbuf.str(string("DATE=$(toolbox date ",quote,"+%Y %m %d %H %M %S",quote,");cat ./PB_ADC_C >> /sdcard/PB_ADC_L;echo ",quote))
      outbuf.dec(adc.getLast(0))
      outbuf.tx(" ")         
      outbuf.dec(adc.getLast(1))
      outbuf.tx(" ")
      outbuf.dec(adc.getLast(2))
      outbuf.tx(" ")
      outbuf.str(string(" $DATE",quote," > ./PB_ADC_C",13))
      cmd(@outbufmem,CONNECTION_ADC)
      logcycle:=log_period
      logcycles++

 else

   chin~    
  repeat
    chin := term.rxcheck
   if (chin>-1)
    inbuf.tx(chin)
    if (chin==13 or inbuf.remaining < 80)
    
     if (byte[@inbufmem]=="@")
       bytemove(@nextcommand,@inbufmem+1,128)
       inbuf.zap(0)
     elseif (byte[@inbufmem]==">") 
      if (byte[@inbufmem+1]=="<") 
        p.off(p#PWR_PHONE)
        reboot
        
      byte[@inbufmem+1+strsize(@inbufmem+1)-1]~ 
      outbuf.zap(0)
      outbuf.str(string("cat ./PB_O_C >> /sdcard/PB_O_L;echo "))
      'outbuf.str(string("echo "))
      outbuf.str(@inbufmem+1)
      outbuf.str(string(" > ./PB_O_C",13,10))
      cmd(@outbufmem,CONNECTION_L)
      inbuf.zap(0)
      'cmd(string("cat ./PB_O_C >> /sdcard/PB_O_L",13),CONNECTION_L)

     else

      bytemove(@lastcommand,@inbufmem,128)
      CommandQueued~~
      cmd(@lastcommand,CONNECTION_SHELL)
      inbuf.zap(0)

  until chin==-1

con
log_period = 5
quote = 34


pri ExecuteCommandIfThere
    if strsize(@nextcommand)
        repeat 3
          term.tx(":")
        term.tx("@")
        term.str(@nextcommand)
        term.tx(13)
        bytefill(@nextcommand,0,128)
pri cmd(what, who)
listen
result:=adb.str(what,who)
listen   
CommandsExpected++

if (globalecho and CommandsExpected < -2)
    CommandsExpected:=-2
if (CommandsExpected > 0)
    CommandsExpected~
    term.tx("[")
    term.dec(logcycles)
    term.tx("]")

    abort -999


pri listendebug
 
    return
    term.tx(",")
    term.tx(",")
    term.tx(",")
    term.dec(adb.debug_message_command)
    term.tx(",")
    term.dec(adb.debug_message_arg0)
    term.tx(",")
    term.dec(adb.debug_message_arg1)
    term.tx("=")
    term.tx(">")
    term.dec(adb.debug_activeconn)
    term.tx(",")
    term.dec(adb.debug_stat(adb.debug_activeconn))
    term.tx(13)
pri derpdebug : a
  return
   
  term.dec(logcycle)
  a~
  term.tx(" ")
  repeat adb#NUMCONNS
    term.dec(a)
    term.tx(",")
    term.dec(adb.debug_loc(a))
    term.tx(",")
    term.dec(adb.debug_rem(a))
    term.tx(",")
    term.dec(adb.debug_stat(a))
    term.tx(" ")
    a++
  term.tx(13)
  

  


pri listen
  result~~
  repeat 

   result := adb.rx
   if (adb.debug_message_command)
     CommandsExpected-=2
   listendebug

   if (result) ' can this be done better?
     CommandsExpected-=2
     if (adb.id == CONNECTION_SHELL)
        CommandQueued~
     if (adb.id == CONNECTION_LCAT)
        bytemove(@nextcommand,adb.rxbuf,128)
        
     if (EchoConnection(adb.id))
       if (strsize(adb.rxbuf)>1)
         term.tx("{")
         term.dec(adb.id)
         term.tx("|")
         term.dec(strsize(adb.rxbuf))
         term.tx("}")
         term.tx(13)
         term.str(adb.rxbuf)
     adb.rxclr
  until result==0

pri EchoConnection(which)
    if (globalecho==0 or which==CONNECTION_ADC or which==CONNECTION_L)
         return false
    return true
var
long logcycles
long chin
byte globalecho
byte inbufmem[128]
byte outbufmem[256]
long CommandsExpected
byte CommandQueued